# *****************************************************************************************************************************
# *****************************************************************************************************************************
# **                                                                                                                         **
# **                                                  INFORMATIONS GÉNÉRALES                                                 **
# **                                                                                                                         **
# *****************************************************************************************************************************
# *****************************************************************************************************************************


"""
Readme

"""

# *****************************************************************************************************************************
# *****************************************************************************************************************************
# **                                                                                                                         **
# **                                          IMPORTS ET DONNÉES GÉNÉRALES COMMUNES                                          **
# **                                                                                                                         **
# *****************************************************************************************************************************
# *****************************************************************************************************************************

import IPython.display as display

# liste des messages d'aide, un dictionnaire de messages par question
tab_aide = []

# liste des messages de vérification, un dictionnaire de messages par question
tab_verif = []


# *****************************************************************************************************************************
# *****************************************************************************************************************************
# **                                                                                                                         **
# **                                                      DONNÉES DE L'ACTIVITÉ                                              **
# **                                                                                                                         **
# *****************************************************************************************************************************
# *****************************************************************************************************************************

liste_objets = [{'Nom': 'A', 'Masse':23, 'Prix':500},
                {'Nom': 'B', 'Masse':12, 'Prix':350},
                {'Nom': 'C', 'Masse': 8, 'Prix':400},
                {'Nom': 'D', 'Masse':11, 'Prix':300}]
                
# ------------ fonction combinaisons_k pour l'exerce 3

def combinaisons_k(seq, k):
    p = []
    i, imax = 0, 2**len(seq)-1
    while i<=imax:
        s = []
        j, jmax = 0, len(seq)-1
        while j<=jmax:
            if (i>>j)&1==1:
                s.append(seq[j])
            j += 1
        if len(s)==k:
            p.append(s)
        i += 1 
    return p
    
# *****************************************************************************************************************************
# *****************************************************************************************************************************
# **                                                                                                                         **
# **                                  MESSSAGES À AFFICHER POUR LES AIDES ET LES VERIFICATIONS                               **
# **                                                                                                                         **
# *****************************************************************************************************************************
# *****************************************************************************************************************************


# ---------------------------------------------------------------------------------------------------------------- EXERCICE 1
# ------------------------------------------------------------------------------------------- EXERCICE 1 question 1

dico_aide = {'question' : 1,

1 :
"""
!!! tip Aide n°1
Déterminer toutes les combinaisons possibles
de remplissage du sac avec 0, 1, 2, 3 ou 4 objets,
sans dépasser 30 kg.
!!!
""",

2 :
"""
!!! tip Aide n°2
Parmi les combinaisons de masse inférieure à 30 kg,
retenir celle qui permet un gain maximal en euros.
!!!
"""
}

dico_verif = {'question' : 1, 'solution' : [['B','C'], ['C','B']],

# vérifications par defaut
              
'code_correct' :
"""
!!! success Correct
Le gain maximal est de 750 euros pour une masse de 20 kg
!!!
""",

              
'code_type' :
"""
!!! warning Attention
- la réponse doit être une liste
- dans la liste, le type des noms des objets est `str`. Exemple : `['A']`.
!!!
""",

        
'code_faux' :
"""
!!! failure Faux
Le gain n'est pas maximal.
!!!
""",
              
# vérifications tierces
# en-tête #0 -> erreur non décomptée
# en-tête #1 -> erreur décomptée
# variable <retour>: vaut True si erreur avérée
              
"""
#0
global retour
retour = False
for objet in reponse:
    present = False
    for dico_objet in liste_objets:
        if objet == dico_objet['Nom']:
            present = True
            break
if not present :
    retour = True
""" :
"""
!!! warning Attention
Objet inconnu : 
- choisir vos objets parmi ceux proposés
- attention aux majuscules.
!!!
""",
              

"""
#1
global retour
retour = False
occurrences = {"A":0, "B":0, "C":0, "D":0}
for objet in reponse:      
    occurrences[objet] += 1
    if occurrences[objet] > 1:
        retour = True
        break
""" :
"""
!!! warning Attention
On ne peut pas sélectionner deux fois le même objet.
!!!
""",
              
    
"""
#1
global retour
retour = False
masse_totale = 0
for objet in reponse: 
    for dico_objet in liste_objets:
        if objet == dico_objet['Nom']:
            masse_totale += dico_objet['Masse']
            if masse_totale > 30:
                retour = True
                break
""":
"""
!!! warning Attention
La masse du sac dépasse 30 kg.
!!!
"""
                              
}
                
tab_verif.append(dico_verif)
tab_aide.append(dico_aide)

# ------------------------------------------------------------------------------------------- EXERCICE 1 question 2

dico_aide = {'question' : 2,

1 :  
"""
!!! tip Aide n°1
Déterminer toutes les combinaisons possibles
de remplissage du sac avec 0, 1, 2, 3 ou 4 objets 
(indépendamment de l'ordre de remplissage, et sans limite de masse).
!!!
""",

2 :
"""
!!! tip Aide n°2
Dénombrer d'abord : 
- les quatre combinaisons comportant 1 seul objet
- puis les six combinaisons comportant 2 objets.
!!!
""",

3 : 
"""
!!! tip Aide n°3
Combinaisons comportant 1 ou 2 objets :

| 1 objet | 2 objets |
|:-------:|:--------:|
| A       | A,B      |
| B       | A,C      |
| C       | A,D      |
| D       | B,C      |
|         | B,D      |
|         | C,D      |

!!!
""",

4 :
    
"""
!!! tip Aide n°4
Dénombrer ensuite les combinaisons comportant 3 objets, puis 4 objets.
!!!
"""
}    

dico_verif = {'question' : 2, 'solution' : [16],

# vérifications par defaut
              
'code_correct' :
"""
!!! success Correct
Il y a bien 16 combinaisons possibles.
!!!
""",

'code_type' :
"""
!!! warning Attention
La réponse saisie doit être de type `int`
!!!
""",

'code_faux' :
"""
!!! failure Faux
Mauvaise réponse
!!!
""",
              
# vérifications tierces
# en-tête #0 -> erreur non décomptée
# en-tête #1 -> erreur décomptée
# variable <retour>: vaut True si erreur avérée

"""
#1
global retour
retour = False
if reponse > 16:
    retour = True

""" :
"""
!!! warning Attention
Il y en a trop : il faut éviter les doublons.
En effet, l'odre de remplissage n'a pas d'importance : par exemple, les combinaisons (A,B) et (B,A) sont les mêmes !
!!!
""",

"""
#1
global retour
retour = False
if reponse == 15:
    retour = True

""" :
"""
!!! warning Attention
Il en manque : vous avez peut-être oublié la combinaison à zéro objet.
!!!
""",

"""
#1
global retour
retour = False
if reponse < 15:
    retour = True

""" :
"""
!!! failure Faux
Il en manque.
!!!
"""                              
}
                
tab_verif.append(dico_verif)
tab_aide.append(dico_aide)
    
# ------------------------------------------------------------------------------------------- EXERCICE 1 question 3

dico_aide = {'question' : 3,

1 :
"""
!!! tip Aide n°1
Exprimer le nombre de combinaisons de 4 objets (16) sous forme d'une puissance de 2 
(saisir un string de la forme `'2**...'`).
!!!
""",

2 :
"""
!!! tip Aide n°2
On remarque que 16 = 2**4
!!!
""",

3 :  
"""
!!! tip Aide n°3
- si on a 4 objets, le nombre de combinaisons est 16, soit 2**4.
- si on a 5 objets, le nombre de combinaisons est 32, soit 2**5.
!!!
"""
}

dico_verif = {'question' : 3, 'solution' : ['2**n'],

# vérifications par defaut
              
'code_correct' :
"""
!!! success Correct
La complexité est bien $O(2^{n})$.
!!!

!!! note Remarque
### D'ailleurs, on aurait pu le deviner dès la première question. En effet:
- pour chaque objet, il y a deux états possibles : on le met dans le sac, ou on ne l'y met pas
- il y a n objets avec chacun 2 états possibles, donc $2^{n}$ combinaisons
!!!
""",

'code_type' :
"""
!!! warning Attention
La réponse saisie doit être de type `str`.
!!!
""",

'code_faux' :
"""
!!! failure Faux
Mauvaise réponse. (Re)lire la consigne et les aides.
!!!
"""
              
# vérifications tierces
# en-tête #0 -> erreur non décomptée
# en-tête #1 -> erreur décomptée
# variable <retour>: vaut True si erreur avérée

}

tab_aide.append(dico_aide)
tab_verif.append(dico_verif)
# ------------------------------------------------------------------------------------------- EXERCICE 1 question 4

dico_aide = {'question' : 4,

1 :
"""
!!! tip Aide n°1
Lire les 1ère et 2ème colonnes du tableau.
!!!
"""
}

dico_verif = {'question' : 4, 'solution' : ['exponentielle', 'exponentiel'],

# vérifications par defaut
              
'code_correct' :
"""
!!! success Correct
Il s'agit bien d'une complexité **exponentielle**.
!!!

!!! danger Conclusion
Cet algorithme n'est pas efficace pour de grandes valeurs de n.
!!!
""",

'code_type' :
"""
!!! warning Attention
La réponse saisie doit être de type `str`.
!!!
""",

'code_faux' :
"""
!!! failure Faux
Mauvaise réponse : 
- écrire un seul mot
- écrire en minuscules
- vérifier l'orthographe
- (Re)lire la consigne et les aides.
!!!
"""
              
# vérifications tierces
# en-tête #0 -> erreur non décomptée
# en-tête #1 -> erreur décomptée
# variable <retour>: vaut True si erreur avérée

}

tab_aide.append(dico_aide)
tab_verif.append(dico_verif)

# ---------------------------------------------------------------------------------------------------------------- EXERCICE 2
# ------------------------------------------------------------------------------------------- EXERCICE 2 question 5

dico_aide = {'question' : 5,

1 :
"""
!!! tip Aide n°1
Remplir le sac en choisissant les objets du plus léger au plus lourd, sans dépasser 30 kg, 
et noter le gain total obtenu à la fin du remplissage.
!!!
"""
}

dico_verif = {'question' : 5, 'solution' : [700],

# vérifications par defaut
              
'code_correct' :
"""
!!! success Correct
Le gain est bien de 700 euros pour une masse de 19 kg en choisissant les objets C et D.

Mais ce n'est pas le gain optimal déterminé à l'exercice 1.
!!!
""",

'code_type' :
"""
!!! warning Attention
La réponse saisie doit être de type `int`.
!!!
""",

'code_faux' :
"""
!!! failure Faux
Mauvaise réponse : le gain n'est pas correct.
!!!
"""
              
# vérifications tierces
# en-tête #0 -> erreur non décomptée
# en-tête #1 -> erreur décomptée
# variable <retour>: vaut True si erreur avérée

}

tab_aide.append(dico_aide)
tab_verif.append(dico_verif)

# ------------------------------------------------------------------------------------------- EXERCICE 2 question 6

dico_aide = {'question' : 6,

1 :
"""
!!! tip Aide n°1
Remplir le sac en choisissant les objets du plus cher au moins cher, sans dépasser 30 kg, 
et noter le gain total obtenu à la fin du remplissage.
!!!
"""
}

dico_verif = {'question' : 6, 'solution' : [500],

# vérifications par defaut
              
'code_correct' :
"""
!!! success Correct
Le gain est bien de 500 euros pour une masse de 23 kg en choisissant l'objet A.

Mais ce n'est pas le gain optimal déterminé à l'exercice 1.
!!!
""",

'code_type' :
"""
!!! warning Attention
La réponse saisie doit être de type `int`.
!!!
""",

'code_faux' :
"""
!!! failure Faux
Mauvaise réponse : le gain n'est pas correct.
!!!
"""
              
# vérifications tierces
# en-tête #0 -> erreur non décomptée
# en-tête #1 -> erreur décomptée
# variable <retour>: vaut True si erreur avérée

}

tab_aide.append(dico_aide)
tab_verif.append(dico_verif)

# ------------------------------------------------------------------------------------------- EXERCICE 2 question 7

dico_aide = {'question' : 7,

1 :
"""
!!! tip Aide n°1
- Remplir le sac en choisissant les objets de la plus grande valeur massique vers la plus basse,
- sans dépasser 30 kg, et noter le gain total obtenu à la fin du remplissage.
- La valeur massique d'un objet s'obtient en calculant le rapport valeur/masse.
!!!
"""
}

dico_verif = {'question' : 7, 'solution' : [750],

# vérifications par defaut
              
'code_correct' :
"""
!!! success Correct
Le gain est bien de 750 euros pour une masse de 20 kg en choisissant les objets B et C.

On retrouve le gain maximal de la question 1 de l'exercice 1. 
!!!
""",

'code_type' :
"""
!!! warning Attention
La réponse saisie doit être de type `int`.
!!!
""",

'code_faux' :
"""
!!! failure Faux
Mauvaise réponse : le gain n'est pas correct.
!!!
"""
              
# vérifications tierces
# en-tête #0 -> erreur non décomptée
# en-tête #1 -> erreur décomptée
# variable <retour>: vaut True si erreur avérée

}

tab_aide.append(dico_aide)
tab_verif.append(dico_verif)

# ------------------------------------------------------------------------------------------- EXERCICE 2 question 8

dico_aide = {'question' : 8,

1 :
"""
!!! tip Aide n°1
Chaque fois que l'on place un objet dans le sac, 
on fait une comparaison pour vérifier si la masse maximale n'est pas dépassée.
!!!
"""
}

dico_verif = {'question' : 8, 'solution' : [3],

# vérifications par defaut
              
'code_correct' :
"""
!!! success Correct
On a effectué 3 comparaisons.
!!!

!!! note Remarque
Attention, on n'a pas pris en compte le coût du tri de la liste d'objets. Mais les algorithmes de tri efficaces existent,
on s'est donc concentré sur le remplissage du sac en lui-même.

On remarque tout de même que pour la force brute, on a fait 16 opérations
rien que pour déterminer toutes les combinaisons, sans compter les comparaisons à effectuer ensuite.

L'algorithme glouton apparaît donc plus efficace.
!!!

""",

'code_type' :
"""
!!! warning Attention
La réponse saisie doit être de type `int`.
!!!
""",

'code_faux' :
"""
!!! failure Faux
Mauvaise réponse : (re)lire les aides.
!!!
"""
              
# vérifications tierces
# en-tête #0 -> erreur non décomptée
# en-tête #1 -> erreur décomptée
# variable <retour>: vaut True si erreur avérée

}

tab_aide.append(dico_aide)
tab_verif.append(dico_verif)

# ---------------------------------------------------------------------------------------------------------------- EXERCICE 3
# ------------------------------------------------------------------------------------------- EXERCICE 3 question 9

dico_aide = {'question' : 9,

1 :
"""
!!! tip Aide n°1
Pour chaque dictionnaire de la liste `objets`, 
il faut ajouter la valeur de la clé `'Nom'` à la liste qui doit être renvoyée.
!!!
""",

2 :    
"""
!!! tip Aide n°2
- Parcourir la liste de dictionnaires avec une boucle for.
- Dans le corps de la boucle, on ajoute la valeur de la clé `'Nom'` à la liste qui doit être renvoyée.
!!!
""",

3 :    
"""
!!! tip Aide n°3
Les lignes suivantes doivent apparaître et sont à compléter :

```python
  
for objet in ... :
    ...append(objet...)
```
!!!
""",

4 :
"""
!!! tip Aide n°4
**Voici un pseudo-code:**

```
L <- liste vide
Pour chaque dictionnaire objet de la liste objets
Faire
    L <- ajouter le nom de l'objet
fin Pour
```
!!!
""",

5 :    
"""<iframe src="https://www.codepuzzle.io/IPYWFQ" width="100%" height="600" frameborder="0"></iframe>"""
}

tab_aide.append(dico_aide)

# ------------------------------------------------------------------------------------------ EXERCICE 3 question 10

dico_aide = {'question' : 10,

1 :
"""
!!! tip Aide n°1
Utiliser les fonctions `liste_noms_objets` et `_exo.combinaisons_k` pour créer la liste
des combinaisons de k objets, et ajouter chaque élément de cette liste à la liste qui doit être renvoyée.
!!!
""",

2 :
"""
!!! tip Aide n°2
Dans l'appel `_exo.combinaisons_k(seq, k)`:
- `seq` est la liste renvoyée par l'appel `liste_noms_objets(objets)`
- `k` prend toutes les valeurs comprises entre 0 et `len(objets)` inclus
- chaque élément de la liste des combinaisions de k objets est ajouté à la liste qui doit être renvoyée.
!!!
""",

3 :
"""
!!! tip Aide n°3
- créer une boucle for sur `k` qui varie de 0 à `len(objets)` inclus
- dans le corps de la boucle : 
    - créer la liste des combinaisons de k objets
    - ajouter chaque élément de cette liste à la liste qui doit être renvoyée
!!!
""",

4 :     
"""
!!! tip Aide n°4
Les lignes suivantes doivent apparaître et sont à compléter :

```python
tab = []
for k in range(...):
    L = _exo.combinaisons_k(..., ...)
```
!!!
""",

5 :
"""
!!! tip Aide n°5
**Voici un pseudo-code:**

```
tab <- liste vide
Pour k variant de 0 à len(objets) inclus
Faire
    L <- liste des combinaisons de k éléments de objets
    Pour chaque combinaison de k éléments dans L
    Faire
        tab <- ajouter la combinaison
    Fin Pour
Fin Pour
```
!!!
""",

6 :   
"""<iframe src="https://www.codepuzzle.io/IP9GXP" width="100%" height="400" frameborder="0"></iframe>"""
    
}

tab_aide.append(dico_aide)

# ------------------------------------------------------------------------------------------ EXERCICE 3 question 11

dico_aide = {'question' : 11,

1 :
"""
!!! tip Aide n°1
- utiliser la liste renvoyée par la fonction `toutes_combinaisons`
- pour chaque combinaison de cette liste :
    - créer un dictionnaire {`'combi'`: cette combinaison, `'masse'`: masse du sac, `'prix'`: gain total}
    - incrémenter les valeurs masse du sac et gain total selon les objets présents dans cette combinaison
!!!
""",

2 :
"""
!!! tip Aide n°2
Les lignes suivantes doivent apparaître et sont à compléter :

```python
liste_dico_combi = []
L = toutes_combinaisons(objets)
for combi in ...:
    dico ={}
    dico['combi'] = ...
    dico['masse'] = 0
    dico['prix'] = 0
```
!!!
""",

3 :
"""
!!! tip Aide n°3
Les lignes suivantes doivent apparaître et sont à compléter :

```python
for nom in combi:
    for objet in objets:
        if objet['Nom'] == ... :
            dico['masse'] += ...
            dico['prix'] += ...
```
!!!
""",

4 :
"""
!!! tip Aide n°4
**Voici un pseudo-code:**

```
liste_dico_combi <- liste vide
L <- liste de toutes les combinaisons possibles
Pour chaque combinaison combi de L
Faire
    dico <- dictionnaire vide
    créer une clé 'combi' de valeur combi
    créer une clé 'masse' de valeur 0
    créer une clé 'prix' de valeur 0
    Pour chaque nom dans combi
    Faire
        Pour chaque dictionnaire objet dans la liste objets
        Faire
            Si la clé 'Nom' de objet est égale à nom
            Faire
                valeur de la clé 'masse' de dico <- ajouter valeur de la clé 'Masse' de objet
                valeur de la clé 'prix' de dico <- ajouter valeur de la clé 'Prix' de objet
        Fin Pour
    Fin Pour
    liste_dico_combi <- ajouter dico
Fin Pour
```
!!!
""",

5 :
"""<iframe src="https://www.codepuzzle.io/IPUVNR" width="100%" height="700" frameborder="0"></iframe>"""  
}

tab_aide.append(dico_aide)

# ------------------------------------------------------------------------------------------ EXERCICE 3 question 12

dico_aide = {'question' : 12,

1 :
"""
!!! tip Aide n°1
- utiliser la liste renvoyée par la fonction `liste_dico_combinaisons`
- pour chaque dictionnaire de cette liste :
    - comparer la masse du sac avec `masse_max`
    - comparer le prix du sac avec le gain maximal déjà rencontré précédemment
!!!
""",

2 :
"""
!!! tip Aide n°2
Les lignes suivantes doivent apparaître et sont à compléter :

```python
L = ...
gain = ...
for combinaison in L:
    if combinaison[...] <= masse_max ... combinaison[...] > gain :
```
!!!
""",

3 :
"""
!!! tip Aide n°3
**Voici un pseudo-code:**

```
L <- liste de tous les dictionnaires de combinaisons
gain_max <- 0
combi_max <- liste vide
Pour chaque combinaison de L
Faire
    Si la valeur de clé 'masse' <= masse_max et la valeur de la clé 'prix' > gain_max
    Faire
        gain_max <-  valeur de la clé 'prix'
        combi_max <- valeur de la clé 'combi'
Fin Pour
```
!!!
""", 

4 :
"""<iframe src="https://www.codepuzzle.io/IPNJEK" width="100%" height="600" frameborder="0"></iframe>"""

}

tab_aide.append(dico_aide)

# ---------------------------------------------------------------------------------------------------------------- EXERCICE 4
# ------------------------------------------------------------------------------------------ EXERCICE 4 question 13

dico_aide = {'question' : 13,

1 :
"""
!!! tip Aide n°1
Renvoyer le résultat de l'opération : `prix de l'objet divisé par sa masse`
!!!
""",

2 :
"""
!!! tip Aide n°2
Dans le jeu de test, on a défini `objet`. L'instruction `objet['Nom']` renvoie `'C'`
!!!
""",

3 :
"""
!!! tip Aide n°3
Ok mais c'est la dernière :
```python
objet['Prix']/...
```
!!!
"""
}

tab_aide.append(dico_aide)

# ------------------------------------------------------------------------------------------ EXERCICE 4 question 14

dico_aide = {'question' : 14,

1 :
"""
!!! tip Aide n°1
la liste à trier est `objets`
!!!
""",

2 :
"""
!!! tip Aide n°2
Le critère de tri est ce que renvoie la fonction `valeur_massique`.
!!!
""",

3 :
"""
!!! tip Aide n°3
```python
return sorted(..., key = ..., ...)
```
!!!
"""
}

tab_aide.append(dico_aide)

# ------------------------------------------------------------------------------------------ EXERCICE 4 question 15

dico_aide = {'question' : 15,

1 :
"""
!!! tip Aide n°1
- parcourir les dictionnaires triés par valeur massique croissante
- ajouter successivement chaque objet trié à la liste à renvoyer :
    - en vérifiant que la valeur `masse_max` n'est pas dépassée
    - en comptabilisant au fur et à mesure le gain obtenu
!!!
""",

2 :
"""
!!! tip Aide n°2
**Voici un pseudo-code à traduire en Python :**
```
objets_tries ← la liste des objets triés par valeur massique décroissante
gain_max ← 0
masse_sac ← 0
combi_gloutonne <- liste vide
Pour chaque objet de objets_tries
Faire    
    masse_sac <- ajouter masse de l'objet
    Si masse_sac plus petit que masse_max
    Faire
        gain_max <- ajouter le prix de l'objet
        combi_gloutonne <- ajouter le nom de l'objet
Fin Pour  
```
!!!
""",

3 :
"""<iframe src="https://www.codepuzzle.io/IPPJ4V" width="100%" height="600" frameborder="0"></iframe>"""
    
}

tab_aide.append(dico_aide)

# ---------------------------------------------------------------------------------------------------------------- EXERCICE 5
# ------------------------------------------------------------------------------------------ EXERCICE 5 question 16

dico_aide = {'question' : 16,

1 :
"""
!!! tip Aide n°1
Une de ces propositions correspond à la stratégie dite "force brute".
!!!
""",

2 :
"""
!!! tip Aide n°2
Les propositions 2 et 4 sont incompatibles entre elles.
!!!
"""

}

dico_verif = {'question' : 16, 'solution' : [[2, 3], [3, 2]],

# vérifications par defaut
              
'code_correct' :
"""
!!! success Correct
Effectivement, on commence par rendre le billet ou la pièce de valeur la plus élevée, 
ce qui conduit à en rendre le moins possible.
!!!

""",

'code_type' :
"""
!!! warning Attention
- La réponse saisie doit être de type `list`.
- les éléments de cette liste doivent être de type`int`. Exemple : `[1, 2, 3]`.
!!!
""",

'code_faux' :
"""
!!! failure Faux
Mauvaise réponse : (re)lire les consignes et les aides.
!!!
"""
              
# vérifications tierces
# en-tête #0 -> erreur non décomptée
# en-tête #1 -> erreur décomptée
# variable <retour>: vaut True si erreur avérée

}

tab_aide.append(dico_aide)
tab_verif.append(dico_verif)

# ------------------------------------------------------------------------------------------ EXERCICE 5 question 17

dico_aide = {'question' : 17,

1 :
"""
!!! tip Aide n°1
Commencer par rendre 10 ...
!!!
""",

2 :    
"""
!!! tip Aide n°2
... puis 5
!!!
"""
}

dico_verif = {'question' : 17, 'solution' : [[10, 5, 2, 2]],

# vérifications par defaut
              
'code_correct' :
"""
!!! success Correct
C'est la bonne liste
!!!

""",

'code_type' :
"""
!!! warning Attention
- La réponse saisie doit être de type `list`.
- les éléments de cette liste doivent être de type`int`. Exemple : `[1, 2, 3]`.
!!!
""",

'code_faux' :
"""
!!! failure Faux
Mauvaise réponse : (re)lire les consignes et les aides.
!!!
"""
              
# vérifications tierces
# en-tête #0 -> erreur non décomptée
# en-tête #1 -> erreur décomptée
# variable <retour>: vaut True si erreur avérée

}

tab_aide.append(dico_aide)
tab_verif.append(dico_verif)

# ------------------------------------------------------------------------------------------ EXERCICE 5 question 18

dico_aide = {'question' : 18,

1 :
"""
!!! tip Aide n°1
- faire diminuer s jusqu'à que s soit égal à 0
- chaque valeur d'espèce retirée à s doit être inférieure ou égale à s, sinon on passe à l'espèce suivante (plus petite)
- chaque espèce retirée à s est ajouter à une liste qui doit être renvoyée
!!!
""",

2 :
"""
!!! tip Aide n°2
- Initialement, l'espèce de plus grande valeur est à la position `len(especes_disponibles) - 1`
- Puis cette position diminue progressivement à chaque étape
!!!
""",

3 :
"""
!!! tip Aide n°3
la ligne suivante doit apparaître :
```python
while s > 0:
```
!!!
""",

4 :
"""
!!! tip Aide n°4
les lignes suivantes doivent apparaître :
```python
if ... <= s:
    s -=
    ...
else:
    ...
```
!!!
""",

5 :
"""
!!! tip Aide n°5
**Voici un pseudo-code:**
```
indice_plus_grande_espèce <- postion de la plus grande valeur dans especes_disponibles
rendues <- liste vide
Tant que s n'est pas nulle
Faire
    Si valeur d'indice indice_plus_grande_espèce <= s
    Faire
        s <- soustraire valeur d'indice indice_plus_grande_espèce
        rendues <- ajouter valeur d'indice indice_plus_grande_espèce
    Sinon
    Faire
        indice_plus_grande_espèce <- soustraire 1
Fin Tant que      
```
!!!
""",

6 :
"""<iframe src="https://www.codepuzzle.io/IPKUSR" width="100%" height="600" frameborder="0"></iframe>"""
}

tab_aide.append(dico_aide)

# ------------------------------------------------------------------------------------------ EXERCICE 5 question 19

dico_aide = {'question' : 19,

1 :
"""
!!! tip Aide n°1
Rendu optimal : rendre le moins possible de pièces et de billets
!!!
"""
}

dico_verif = {'question' : 19, 'solution' : [[6, 6]],

# vérifications par defaut
              
'code_correct' :
"""
!!! success Correct
C'est la bonne liste
!!!

""",

'code_type' :
"""
!!! warning Attention
- La réponse saisie doit être de type `list`.
- les éléments de cette liste doivent être de type`int`. Exemple : `[1, 2, 3]`.
!!!
""",

'code_faux' :
"""
!!! failure Faux
Mauvaise réponse : (re)lire les consignes et les aides.
!!!
"""
              
# vérifications tierces
# en-tête #0 -> erreur non décomptée
# en-tête #1 -> erreur décomptée
# variable <retour>: vaut True si erreur avérée

}

tab_aide.append(dico_aide)
tab_verif.append(dico_verif)

# ------------------------------------------------------------------------------------------ EXERCICE 5 question 20

dico_aide = {'question' : 20,

1 :
"""
!!! tip Aide n°1
Rendu glouton : commencer par rendre la pièce ou le billet de plus grande valeur
!!!
"""
}

dico_verif = {'question' : 20, 'solution' : [[10, 1, 1]],

# vérifications par defaut
              
'code_correct' :
"""
!!! success Correct
On voit ici que l'algorithme glouton donne un résultat juste mais pas optimal.
!!!

!!! note Remarque :
Un système monétaire permettant de toujours obtenir un résultat optimal avec un algorithme glouton est appelé **système canonique** :
- les euros constituent un système canonique
- le système britanique d'avant 1971 n'était pas canonique (1, 2, 6, 12, 24, 30, 60, 240 livres Sterling):
    - 48 -> 24 + 24 (optimal)
    - 48 -> 30 +12 + 6 avec stratégie gloutonne
!!!
""",

'code_type' :
"""
!!! warning Attention
- La réponse saisie doit être de type `list`.
- les éléments de cette liste doivent être de type`int`. Exemple : `[1, 2, 3]`.
!!!
""",

'code_faux' :
"""
!!! failure Faux
Mauvaise réponse : (re)lire les consignes et les aides.
!!!
"""
              
# vérifications tierces
# en-tête #0 -> erreur non décomptée
# en-tête #1 -> erreur décomptée
# variable <retour>: vaut True si erreur avérée

}

tab_aide.append(dico_aide)
tab_verif.append(dico_verif)

# ------------------------------------------------------------------------------------------ EXERCICE 5 question 21

dico_aide = {'question' : 21,

1 :
"""
!!! tip Aide n°1
Rendu optimal : rendre le moins possible de pièces et de billets
!!!
"""
}

dico_verif = {'question' : 21, 'solution' : [[20, 2, 2, 2]],

# vérifications par defaut
              
'code_correct' :
"""
!!! success Correct
C'est la bonne liste
!!!

""",

'code_type' :
"""
!!! warning Attention
- La réponse saisie doit être de type `list`.Il n'y a pas d'aide correspondant à ce numéro.
- les éléments de cette liste doivent être de type`int`. Exemple : `[1, 2, 3]`.
!!!
""",

'code_faux' :
"""
!!! failure Faux
Mauvaise réponse : (re)lire les consignes et les aides.
!!!
"""
              
# vérifications tierces
# en-tête #0 -> erreur non décomptée
# en-tête #1 -> erreur décomptée
# variable <retour>: vaut True si erreur avérée

}

tab_aide.append(dico_aide)
tab_verif.append(dico_verif)

# ------------------------------------------------------------------------------------------ EXERCICE 5 question 22

dico_aide = {'question' : 22,

1 :
"""
!!! tip Aide n°1
Rendu glouton : commencer par rendre la pièce ou le billet de plus grande valeur
!!!
"""
}

dico_verif = {'question' : 22, 'solution' : [[20, 5]],

# vérifications par defaut
              
'code_correct' :
"""
!!! success Correct
On voit ici que l'algorithme glouton donne un résultat **faux** : 25 au lieu de 26 !
!!!

!!! note Remarque :
Une méthode gloutonne peut ne pas donner de solution correcte si, comme ici, le système utilisé est mal choisi.
!!!
""",

'code_type' :
"""
!!! warning Attention
- La réponse saisie doit être de type `list`.
- les éléments de cette liste doivent être de type`int`. Exemple : `[1, 2, 3]`.
!!!
""",

'code_faux' :
"""
!!! failure Faux
Mauvaise réponse : (re)lire les consignes et les aides.
!!!
"""
              
# vérifications tierces
# en-tête #0 -> erreur non décomptée
# en-tête #1 -> erreur décomptée
# variable <retour>: vaut True si erreur avérée

}

tab_aide.append(dico_aide)
tab_verif.append(dico_verif)

# FIN DES MESSAGES

# *****************************************************************************************************************************
# *****************************************************************************************************************************
# **                                                                                                                         **
# **                                               FONCTIONS GÉNÉRALES                                                       **
# **                                                                                                                         **
# *****************************************************************************************************************************
# *****************************************************************************************************************************

# ------------------------- création du tableau de résultats

def creer_tab_resultats(tab_aide):
    resultats = []
    i = 0
    for dico in tab_aide :
        resultats.append({})
        resultats[i]["question"] = dico['question']
        resultats[i]["aides disponibles"] = len(dico)- 1
        resultats[i]["aides utilisées"] = []
        resultats[i]["échecs"] = 0
        resultats[i]["validée"] = 0
        i += 1
    def tri(resultats):
        return resultats['question']
    return sorted(resultats, key = tri)

resultats = creer_tab_resultats(tab_aide)

# ----------------------- écrire les résultats dans un fichier .csv

def write_resultats():
    f = open("resultats.csv", "w")
    f.write("question;aides disponibles;aides utilisées;échecs;validée\n")
    for _ in resultats:  
        f.write(str(_["question"]) + ";" + str(_["aides disponibles"]) + ";" + str(_["aides utilisées"]) + ";" + str(_["échecs"])+ ";" + str(_["validée"])+"\n")
    f.close()

# ------------------ afficher les résultats dans un tableau markdown

def tableau_resultats():
    table = "|"
    for entete in resultats[0].keys():
        table += entete
        table += "|"

    table += "\n|"

    for i in range(len(resultats[0])):
        table += ":-:|"

    table += "\n"

    for i in range(len(resultats)):
        table += "|"
        for data in resultats[i].values():
            table += str(data)
            table += "|"
        table += "\n"
    return display.Markdown(table)
    
# -------------------------- affichage des aides + remplissage tableau resultat
# les aides et les échecs ne sont pas décomptés si la question a déjà été validée

# ---------- message affiché lorsque les aides
# ne sont pas demandées progressivement dans l'ordre
ordre = """
!!! bug Ordre des aides
Utilisez d'abord les aides précédentes avant de demander celle-ci.
!!!
"""

# ---------- message affiché lorsque les aides sont épuisées pour une question
fini = """
!!! bug Numéro indisponible
Il n'y a pas d'aide correspondant à ce numéro.
!!!
"""

def aide(q,n):

    # numéro de la question -> accès au dico aide
    for dico_aide in tab_aide:
        if dico_aide['question'] == q:
            break

    # numéro de la question -> accès au dico resultat
    for dico_resultat in resultats :
        if dico_resultat['question'] == q:
            break        

    if n in dico_aide.keys() :
        if dico_resultat["validée"] == 0 :
            if n > 1 and n-1 not in dico_resultat["aides utilisées"]:
                return display.Markdown(ordre)
            if n not in dico_resultat["aides utilisées"]:
                dico_resultat["aides utilisées"].append(n)
                write_resultats()
            if '</iframe>' in dico_aide[n]:
                return display.HTML(dico_aide[n])
            else:
                return display.Markdown(dico_aide[n])
        else:
            if '</iframe>' in dico_aide[n]:
                return display.HTML(dico_aide[n])
            else:
                return display.Markdown(dico_aide[n])
    else :
        return display.Markdown(fini)


# *****************************************************************************************************************************
# *****************************************************************************************************************************
# **                                                                                                                         **
# **                                              FONCTIONS DE VÉRIFICATION                                                   **
# **                                                                                                                         **
# *****************************************************************************************************************************
# *****************************************************************************************************************************

# ------------------------ vérifications des assertions des fonctions à écrire

# ---------- message affiché lorsque le programme est validé
valide = """
!!! success Correct

!!!
"""

# ---------- message affiché si erreur assertion
assertion_err = """
!!! failure AssertionError

!!!
"""

def verif_assert(q,reponse):

    # numéro de la question -> accès au dico resultat
    for dico_resultat in resultats :
        if dico_resultat['question'] == q:
            break
    
    if 'AssertionError' in reponse :
        if dico_resultat["validée"] == 0:
            dico_resultat["échecs"] += 1
            write_resultats()
        return display.Markdown(assertion_err)    
        
    else :
        dico_resultat["validée"] = 1
        write_resultats()
        return display.Markdown(valide)

# ------------------------ vérifications des réponses (sans assertions)
  
def verif(q, reponse):
    
    # numéro de la question -> accès au dico verif
    for dico_verif in tab_verif :
        if dico_verif['question'] == q:
            break
            
    # numéro de la question -> accès au dico resultat
    for dico_resultat in resultats :
        if dico_resultat['question'] == q:
            break
            
    # -------------------------------------- erreurs non décomptées
    #(à déplacer dans la section non "erreurs décomptées" si besoin
    
    # erreur "type reponse"
    if type(reponse) != type(dico_verif['solution'][0]):
        return display.Markdown(dico_verif['code_type'])
        
    # erreur "type élément" de reponse si c'est une liste
    if type(dico_verif['solution'][0]) == list:
        for elem in reponse:
            if type (elem) != type(dico_verif['solution'][0][0]):
                return display.Markdown(dico_verif['code_type'])
                
    # erreurs non décomptées personnaliséés
    
    for test in dico_verif.keys():
            if '#0' in test :
                exec(test)
                if retour:
                    return display.Markdown(dico_verif[test])
    
    # si bonne réponse
    for sol in dico_verif['solution']:
        if sol == reponse:          
            dico_resultat["validée"] = 1
            write_resultats()
            return display.Markdown(dico_verif['code_correct'])
    
    else : 
        
        # décompte erreur
        if dico_resultat["validée"] == 0:
            dico_resultat["échecs"] += 1
            write_resultats()
            
        # erreurs décomptées personnalisées
        for test in dico_verif.keys():
            if '#1' in test :
                exec(test)
                if retour:
                    return display.Markdown(dico_verif[test])
                    
        # erreur décomptée par défaut    
        return display.Markdown(dico_verif['code_faux'])
        




